#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five8004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five8004xi = {
                1: '-112x498y615z',
                2: '-114x258y748z',
                3: '-115x541y577z',
                4: '-126x735y288z',
                5: '-131x259y745z',
                6: '-139x497y610z',
                7: '-144x539y572z',
                8: '-148x258y742z',
                9: '-165x256y739z',
                10: '-165x730y281z',
                11: '-167x495y605z',
                12: '-174x537y566z',
                13: '-17x4y799z',
                14: '-182x253y736z',
                15: '-195x491y600z',
                16: '-1x0y799z',
                17: '-200x249y733z',
                18: '-204x532y561z',
                19: '-204x723y273z',
                20: '-218x243y729z',
                21: '-223x486y594z',
                22: '-234x526y555z',
                23: '-235x237y726z',
                24: '-242x714y266z',
                25: '-24x236y763z',
                26: '-251x478y589z',
                27: '-253x229y723z',
                28: '-25x5y799z',
                29: '-263x518y549z',
                30: '-270x220y719z',
                31: '-279x470y583z',
                32: '-280x702y258z',
                33: '-287x210y716z',
                34: '-293x508y543z',
                35: '-304x198y712z',
                36: '-306x459y578z',
                37: '-318x689y251z',
                38: '-320x186y709z',
                39: '-322x496y537z',
                40: '-333x447y572z',
                41: '-335x172y705z',
                42: '-33x5y799z',
                43: '-350x157y701z',
                44: '-351x483y531z',
                45: '-355x674y243z',
                46: '-360x433y567z',
                47: '-365x141y697z',
                48: '-378x124y693z',
                49: '-379x468y525z',
                50: '-37x242y761z',
                51: '-386x418y561z',
                52: '-391x106y689z',
                53: '-391x656y235z',
                54: '-403x87y685z',
                55: '-406x451y519z',
                56: '-411x401y555z',
                57: '-413x66y681z',
                58: '-41x4y798z',
                59: '-423x45y677z',
                60: '-426x637y228z',
                61: '-432x24y672z',
                62: '-433x433y513z',
                63: '-436x383y550z',
                64: '-439x1y668z',
                65: '-459x413y507z',
                66: '-460x363y544z',
                67: '-460x615y220z',
                68: '-482x341y538z',
                69: '-484x392y501z',
                70: '-493x592y212z',
                71: '-49x2y798z',
                72: '-504x318y532z',
                73: '-508x369y495z',
                74: '-51x247y759z',
                75: '-525x294y526z',
                76: '-525x567y205z',
                77: '-531x344y488z',
                78: '-544x269y520z',
                79: '-552x319y482z',
                80: '-555x540y197z',
                81: '-562x242y514z',
                82: '-56x538y588z',
                83: '-572x291y475z',
                84: '-579x214y508z',
                85: '-57x0y797z',
                86: '-584x512y189z',
                87: '-591x263y469z',
                88: '-594x185y501z',
                89: '-608x155y495z',
                90: '-609x233y463z',
                91: '-612x482y181z',
                92: '-620x123y489z',
                93: '-624x203y456z',
                94: '-631x91y483z',
                95: '-637x450y174z',
                96: '-638x171y449z',
                97: '-639x59y476z',
                98: '-651x138y443z',
                99: '-662x104y436z',
                100: '-662x417y166z',
                101: '-66x251y756z',
                102: '-671x70y429z',
                103: '-678x35y423z',
                104: '-683x0y416z',
                105: '-684x382y158z',
                106: '-704x347y150z',
                107: '-723x310y142z',
                108: '-727x29y528z',
                109: '-739x272y134z',
                110: '-754x233y126z',
                111: '-766x194y119z',
                112: '-777x154y111z',
                113: '-785x113y103z',
                114: '-791x72y95z',
                115: '-794x30y87z',
                116: '-81x255y753z',
                117: '-85x497y620z',
                118: '-85x540y583z',
                119: '-87x737y296z',
                120: '-97x257y751z',
                121: '-9x3y799z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire800five4xi" usage = "target function for charge8004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire800five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE800FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five8004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five8004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE800FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800five4xi.py                             
# -------------------------------------------------------------------------------------------------                